/***************************************************************************
 *   Copyright (C) 2005 by Siraj Razick                                    *
 *   siraj@kdemail.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "kbfxspinxlistbox.h"
//#include "cursor.xpm"
#include <qimage.h>
//#include <qpixmap.h>
#include <qapplication.h>
#include <qevent.h>
#include <qdragobject.h>


void
KbfxSpinxListBox::dragLeaveEvent (QDragLeaveEvent * e)
{
  e = e;
}

void
KbfxSpinxListBox::dragMoveEvent (QDragMoveEvent * e)
{
  e = e;
}

void
KbfxSpinxListBox::scroll (int delta)
{

  QWheelEvent we (QCursor::pos (), delta, Qt::NoButton);
  QApplication::sendEvent (this, &we);

}


void
KbfxSpinxListBox::scrollRest (int x)
{
  x = x;
  if (_type != 1)
    {
      this->move (this->x (), 0);
      scrolllen = 0;
    }

}


void
KbfxSpinxListBox::wheelEvent (QWheelEvent * e)
{
/*
  uint count = this->count (); //- this->sepCount();
  uint sepH= 27;
  e->accept ();
  QListBoxItem *_item = this->firstItem ();
  if (_item == NULL || count < 6)
    return;
 sepH = _item->height(this);

 _item = this->item(1);
 if(_item == NULL)
	return;
 
 this->setGeometry (this->x (), this->y (), _item->width (this),
			(_item->height (this) * (count)));

//		     (_item->height (this) * (count+1))+(sepH*sepCount())+1000);



//  int visible = (_item->height (this) * (count - 5)) + (sepH*sepCount());
  int visible  = (_item->height (this) * (count));//+(sepH*sepCount());
  if (_type == 1)
    {
      visible = (_item->height (this) * (count - 10));
    }

  if (e->delta () < 0 && scrolllen < visible && count > 4)
    {

   	 this->move(this->x (), this->y () - _item->height (this)); 
 	 scrolllen += _item->height (this);
	
    }
  else if (e->delta () > 0 && scrolllen != 0 && count > 4)
    {
      this->move (this->x (), this->y () + _item->height (this));
      //mose wheel is moving away
      scrolllen -= _item->height (this);
    }
*/
if(!this->isVisible())
	return;

if(e->delta() < 0)
{
scrollBy(0,y()+50);
}
else if(e->delta() > 0)
{
scrollBy(0,y()-50);
}

}

void
KbfxSpinxListBox::mouseMoveEvent (QMouseEvent * e)
{

  if (e->type () == QEvent::MouseMove && blocked)
    {
      QListBoxItem *_item = this->itemAt (e->pos ());
      *_selected = e->pos ();
	
     VistaListBoxItem * _tmp = (VistaListBoxItem*)_item;
      
      if (_item == NULL)
	{
	  this->clearFocus ();
		setCursor(Qt::ArrowCursor);
	  return;
	}
      else 
	{
	if(_tmp->getType() != 3)
	{
	  QCursor kbfxCursor;
	  kbfxCursor.setShape (Qt::PointingHandCursor);
	  this->setCursor ((const QCursor) kbfxCursor);
	}
	if(_tmp->getType() == 3)
		setCursor(Qt::ArrowCursor);
	}
      this->setFocus ();
      _lastItem = (VistaListBoxItem *) _item;
      emit onItem (_item);
      this->setSelected (_item, true);

    }



}


void
KbfxSpinxListBox::leaveEvent (QEvent * e)
{
  e = e;
  if (!_type)
    this->clearFocus ();

}
